// Table.cpp: CTable NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Table.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CTable::CTable( short lenLV/*=18*/,short stkLV/*=-1*/ )
{
	cur=0;
	end=0;
	memset( data,' ',4096 );
	for( int a=0; a!=256; a++ )
		for( int b=0; b!=256; b++ )
			find[a][b]=NULL;

	lengthLV = lenLV;
	stockLV = stkLV;
}

CTable::~CTable()
{
	for( int a=0; a!=256; a++ )
	{
		for( int b=0; b!=256; b++ )
		{
			POSITION *p,*tmp = find[a][b];
			while( tmp!=NULL )
			{
				p=tmp->next;
				delete tmp;
				tmp=p;
			}
		}
	}
}

static bool IsBetween( long x,long a,long b )
{
//	0  a  x  b  4096
//	0  b  a  x  4096
//  0  x  b  a  4096
//  true
	if( a<x && x<b )return true;
	if( b<a && a<x )return true;
	if( x<b && b<a )return true;
	return false;
}

bool CTable::Find( long* adrs,long* len )
{
	bool bFound = false;

	*len=0;
	// curn܂zƓƂAendcur-1܂łŒTB

	POSITION* tmp = find[ data[cur] ][ data[(cur+1)&0xfff] ];
	while( tmp!=NULL )
	{
		if( !IsBetween( tmp->n , 0xfff&(cur-1), end ) )
		{
			if( data[(cur+2)&0xfff]==data[(tmp->n+2)&0xfff] )
			{
				bFound = true;
				for( long t=3; t!=18; t++ )
				{
					if( data[(cur+t)&0xfff]!=data[(tmp->n+t)&0xfff] || ((cur+t)&0xfff)==end )
						break;
				}
				if( *len<t )
				{
					*len=t,*adrs=tmp->n;
					if( *len>=lengthLV )
						break;
				}
			}
		}
		tmp=tmp->next;
	}

	return bFound;
}

void CTable::AddData( unsigned char d )
{
	// ㏑ĂȂȂAȂo^
		POSITION* tmp;
		tmp=find[ data[end] ][ data[(end+1)&0xfff] ];
		while( tmp!=NULL )
		{
			if( tmp->n!=end )
			{
				tmp=tmp->next;
				continue;
			}
			if( tmp->prev==NULL )find[ data[end] ][ data[(end+1)&0xfff] ]=tmp->next;
			if( tmp->prev!=NULL )tmp->prev->next=tmp->next;
			if( tmp->next!=NULL )tmp->next->prev=tmp->prev;
			delete tmp;
			break;
		}

	data[end]=d;

	// VłAȂo^
		POSITION* p = new POSITION;
		p->n = (end==0)?4095:end-1;
		tmp=find[ data[p->n] ][ data[end] ];

		if( stockLV!=-1 )
		{
			// Ώۂ̌肵Ă܂B
			POSITION* ppp=tmp;
			int c=0;
			while( ppp!=NULL )
			{
				if( c==stockLV )
				{
					ppp->prev->next=NULL;
					delete ppp;
					break;
				}
				ppp=ppp->next;
				c++;
			}
		}

		if( tmp!=NULL )tmp->prev=p;
		p->next=tmp;
		find[ data[p->n] ][ data[end] ]=p;

	end = (end+1)&0xfff;
}
